PROGRAM Linien_Algorithmen_Test;

CONST (*$I TRIXCONS.PAS*)
TYPE  (*$I TRIXTYPE.PAS*)

(*$I TRIXSUBS.PAS*)
(*$I C:\PASCAL\BIBLIOTH\sign*)

VAR
    i
            : integer;
    Auswahl
            : char;
       
PROCEDURE aline (x1, y1, x2, y2: integer);
  BEGIN
    line (x1, y1, x2, y2, 1, 0, 0, 0, 65535, 0);
  END;  
  
PROCEDURE bline (x1, y1, x2, y2: integer);

   PROCEDURE vertausche (VAR a, b: integer);
     VAR hilf: integer;
     BEGIN
       hilf := a;
       a := b;
       b := hilf;
     END; (* vertauschen *)
     
   VAR
       x, y   : integer;   (* alte Koordinaten *)
       Dx, Dy : integer; (* Deltax, Deltay *)
       sx, sy,          (* sign(delta) *)
       e      : integer; 
       vertauscht: BOOLEAN;
       zaehler: integer;
   BEGIN
     x := x1;
     y := y1;
     Dx := abs (x2 - x1);
     Dy := abs (y2 - y1);
     sx := sign (x2 - x1);
     sy := sign (y2 - y1);
     IF Dy > Dx 
        THEN
          BEGIN
            vertausche (Dx, Dy);
            vertauscht := TRUE;
          END (* then *)
        ELSE
          vertauscht := FALSE;
     e := Dy + Dy - Dx;  (* Ende der Initialisierung *)
     
    (* Hauptschleife *)
    
    FOR zaehler := 1 TO Dx DO
        BEGIN
          put_pixel ( x,y,1 );
          WHILE e >= 0 DO
            BEGIN
              IF vertauscht
                 THEN
                   x := x + sx
                 ELSE
                   y := y + sy;
              e := e - Dx - Dx;
            END;  (* while *)
          IF vertauscht 
             THEN
               y := y + sy
             ELSE
               x := x + sx;
          e := e + Dy + Dy;
        END;  (* for *)
    END;  (* bline *)
  
PROCEDURE sline (x1, y1, x2, y2: integer);
   (* Zeichnet die Strecke von (x1;y1) nach (x2;y2); klassisch, also ohne *)
   (* Ganzzahl-Arithmetik                                                 *)

   VAR
       x,
       y,                (* alte Koordinaten *)
       Dx,               (* Deltax *)
       Dy               (* Deltay *)
               : real; 
       Laenge,  
       zaehler : integer;
       
   FUNCTION max (a, b: integer) : integer;
   (* Liefert die grere der Zahlen a, b zurck *)
      BEGIN
        IF a >= b
           THEN max := a
           ELSE max := b;
      END;  (* von max *)
      
   BEGIN
     Laenge := max ( abs(x2-x1), abs(y2-y1) );
     Dx := (x2-x1)/Laenge;
     Dy := (y2-y1)/Laenge;
     x := x1;
     y := y1;
    
     (* Hauptschleife *)
    
     FOR zaehler := 1 TO Laenge DO
         BEGIN
           put_pixel ( round(x), round(y), 1 );
           x := x + Dx;
           y := y + Dy; 
         END;  (* for *)
   END;  (* line *)
   
PROCEDURE geradeaus_zeichnen;
  VAR
      i
        : integer;
  BEGIN
    write ('   Achtung, Stopuhr bereit halten, Programm mit Return starten!');
    readln;
    clear_home;
    FOR i := 0 TO 639 DO
        BEGIN
          sline (0, 0, i, 399);
          sline (639, 399, i, 0);
        END;
  END;  (* geradeaus_zeichnen *)
  
PROCEDURE bresenham_zeichnen;
  VAR
      i
        : integer;
  BEGIN
    write ('   Achtung, Stopuhr bereit halten, Programm mit Return starten!');
    readln;
    clear_home;
    FOR i := 0 TO 639 DO
        BEGIN
          bline (0, 0, i, 399);
          bline (639, 399, i, 0);
        END;
  END;  (* bresenham_zeichnen *)
  
PROCEDURE lineA_zeichnen;
  VAR
      i
        : integer;
  BEGIN
    write ('   Achtung, Stopuhr bereit halten, Programm mit Return starten!');
    readln;
    clear_home;
    FOR i := 0 TO 639 DO
        BEGIN
          aline (0, 0, i, 399);
          aline (639, 399, i, 0);
        END;
  END;  (* lineA_zeichnen *)
  
PROCEDURE fehlermeldung;
  BEGIN
    writeln ('Fehleingabe! Abbruch nach Return');
    readln;
  END;  (* fehlermeldung *)
     
BEGIN
  clear_home;
  writeln;
  writeln ('   Geschwindigkeitstest: ');
  writeln;
  writeln ('   3 Algorithmen zur Auswahl:');
  writeln;
  writeln ('   1   Geradeaus-Algorithmus');
  writeln ('   2   Bresenham-Algorithmus');
  writeln ('   3   Line-A-Algorithmus');
  writeln;
  write ('   Bitte whlen: ');
  cur_on;
  readln (Auswahl);
  cur_off;
  CASE Auswahl OF
       '1': geradeaus_zeichnen;
       '2': bresenham_zeichnen;
       '3': lineA_zeichnen;
       OTHERWISE: fehlermeldung;
  END; (* case *)
  clear_home;
  writeln;
  write ('   Ende! Return drcken.');
  readln;
END.          
            
